#!/usr/local/bin/perl
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# Define Variables

$basedir = "/data1/hypermart.net/freeland/forum";
$baseurl = "http://freeland.hypermart.net/forum";

#siteid MUST be substring of $baseurl

$siteid = "freeland";

$cgi_url = "http://freeland.hypermart.net/forum/mainboard.pl";
$page_url = "http://freeland.hypermart.net/forum/mainpage.pl";

$mesgdir = "messages";
$datafile = "serial.txt";

$usrpwdfile = "xxxx_regpwd.txt";
$trackfile = "xxxx_bywhom.txt";
$baddiefile = "xxxx_badguy.txt";
$dupfile = "xxxx_dup.txt";
$busyfile = "busy.txt";

$mesgfile = "mainboard.html";
$faqfile = "faq.html";

$ext = "html";

$title = "̳ҳ";
$title_p = "̳ҳ";

# Done
###########################################################################

###########################################################################
# Configure Options

$show_faq = 0;		# 1 - YES; 0 = NO
$allow_html = 0;	# 1 = YES; 0 = NO
$quote_text = 0;	# 1 = YES; 0 = NO
$subject_line = 2;	# 0 = Quote Subject Editable; 1 = Quote Subject 
			#   UnEditable; 2 = Don't Quote Subject, Editable.
$use_time = 1;		# 1 = YES; 0 = NO

$max_name_length = 20;
$max_upwd_length = 20;
$max_subj_length = 80;
$max_urim_length = 200;
$max_body_length = 30000;

# Done
###########################################################################

# Get Form Information
&parse_form;

# Load User Password File
&load_usrpwd;

# Put items into nice variables
&get_variables;

# Handle Baddie
&handle_baddie;

# Check Flag
&check_flag;

# Get the Data Number
&get_number;

# Increment Number
&increment_num;

# Update Hits File
&update_hits;

# Open the new file and write information to it.
&new_file;

# Open the Main WWWBoard File to add link
&main_page;

# Now Add Thread to Individual Pages
if ($num_followups >= 1) {
   &thread_pages;
}

# Clear Flag
&clear_flag;

# Return the user HTML
&return_html;

##########################################
# Update Hits File Subroutine

sub update_hits {
    open(HIT, ">>$basedir/$trackfile") || die $!;
    print HIT "$num:$ENV{'REMOTE_ADDR'}:$name\n";
    close(HIT);
}

############################
# Get Data Number Subroutine

sub get_number {
   open(NUMBER,"$basedir/$datafile");
   $num = <NUMBER>;
   close(NUMBER);
   if ($num == 99999)  {
      $num = "1";
   }
   else {
      $num++;
   }
}

#######################
# Parse Form Subroutine

sub parse_form {

   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      # Un-Webify plus signs and %-encoding
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;

      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
      }
      else {
         unless ($name eq 'body') {
	    $value =~ s/<([^>]|\n)*>//g;
         }
      }

      $FORM{$name} = $value;
   }

}

###############################
# Load User Password Subroutine

sub load_usrpwd {

    open(UPW, "$basedir/$usrpwdfile") || die $!;
    while (<UPW>)
    {
	chop();
	($usrnamef, $usrpwdf) = split(/:/);	
	$usrpwdf{$usrnamef} = $usrpwdf;
    }    
    close(UPW);
}

##########################################
# Add User to The Password File Subroutine

sub add_usrpwd {
    open(UPW, ">>$basedir/$usrpwdfile") || die $!;
    print UPW "$name:$usrpwd:$num:\n";
    close(UPW);
}

###############################
# Handle Baddie

sub handle_baddie {

    open(BAD, "$basedir/$baddiefile") || die $!;
    while (<BAD>)
    {
	chop();
	($baddieip) = split(/:/);	
	$baddieip =~ s/\s//g;

        if ($usrip =~ /$baddieip/ && $baddieip)
        {
	    &error(system_busy);
        }
    }
    close(BAD);

    if ($ENV{'HTTP_REFERER'} =~ /$siteid/)
    {
    }
    else
    {
	&error(post_dup);
    }
}

#######################
# Detect Duplicate Post

sub check_dup {

    open(DUP, "$basedir/$dupfile") || die $!;
    while (<DUP>)
    {
	chop();
	($dupip, $dupsubjlength, $dupbodylength) = split(/:/);	
    }
    close(DUP);

    if ($dupip eq $usrip && $dupsubjlength eq $subjlength && $dupbodylength eq $bodylength)
    {
         &error(post_dup);	
    }
    else
    {
    	open(DUP, ">$basedir/$dupfile") || die $!;
    	print DUP "$usrip:$subjlength:$bodylength:\n";
    	close(DUP);
    }
}

###############
# Get Variables

sub get_variables {

   if ($FORM{'followup'}) {
      $followup = "1";
      @followup_num = split(/,/,$FORM{'followup'});
      $num_followups = @followups = @followup_num;
      $last_message = pop(@followups);
      $origdate = "$FORM{'origdate'}";
      $origname = "$FORM{'origname'}";
      $origsubject = "$FORM{'origsubject'}";
   }
   else {
      $followup = "0";
   }

   $name = "$FORM{'name'}";
   $name =~ s/"//g;
   $name =~ s/<//g;
   $name =~ s/>//g;
   $name =~ s/\&//g;
   $name =~ s/\s//g;

   if ($name) {

      $usrpwd = "$FORM{'usrpwd'}";
      $usrpwd =~ s/"//g;
      $usrpwd =~ s/<//g;
      $usrpwd =~ s/>//g;
      $usrpwd =~ s/\&//g;
      $usrpwd =~ s/\s//g;

      if (length($name) < $max_name_length && length($usrpwd) < $max_upwd_length)
      {
      	if ($usrpwdf{$name}) 
      	{
	  $cryptpwd = crypt($usrpwd, substr($usrpwd, 0, 2));
 
	  if ($cryptpwd ne $usrpwdf{$name})
	  {
      	     &error(wrong_pwd);
	  }
      	}
      }
      else
      {
	&error(name_pwd_long);
      }
   }
   else 
   {
      &error(no_name);
   }

   if ($FORM{'email'} =~ /.*\@.*\..*/) {
      $email = "$FORM{'email'}";
   }

   if ($FORM{'subject'}) {
      $subject = "$FORM{'subject'}";
      $subject =~ s/\&/\&amp\;/g;
      $subject =~ s/"/\&quot\;/g;
      $subject =~ s/[\n\r\t\f]//g;
      $subject =~ s/<//g;
      $subject =~ s/>//g;

      $subjlength = length($subject);

      if (length($subject) > $max_subj_length)
      {
         &error(subject_long);
      }   
   }
   else {
      &error(no_subject);
   }

#   if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'}) {

   if ($FORM{'url'} =~ /.*\:.*\..*/ ) {
      $message_url = "$FORM{'url'}";
      $message_url =~ s/"//g;
      $message_url =~ s/<//g;
      $message_url =~ s/>//g;
      $message_url =~ s/\&//g;
      $message_url =~ s/\s//g;

      $message_url_title = "$FORM{'url_title'}";
      $message_url_title =~ s/"//g;
      $message_url_title =~ s/<//g;
      $message_url_title =~ s/>//g;
      $message_url_title =~ s/\&//g;
      $message_url_title =~ s/\s//g;

      if (length($message_url) > $max_urim_length || length($message_url_title) > $max_urim_length)
      {
         &error(urim_long);
      }   

      if (!$message_url_title)
      {
	   $message_url_title = $message_url;
      }
   }

   if ($FORM{'img'} =~ /.*tp:\/\/.*\..*/) {
      $message_img = "$FORM{'img'}";
      $message_img =~ s/"//g;
      $message_img =~ s/<//g;
      $message_img =~ s/>//g;
      $message_img =~ s/\&//g;
      $message_img =~ s/\s//g;

      if (length($message_img) > $max_urim_length)
      {
         &error(urim_long);
      }  
   }

   if ($FORM{'body'}) {
      $body = "$FORM{'body'}";
      $body =~ s/\cM//g;
      $body =~ s/\n\n/<p>/g;
      $body =~ s/\n/<br>/g;

      $body =~ s/&lt;/</g; 
      $body =~ s/&gt;/>/g; 
      $body =~ s/&quot;/"/g;

#  special measure

#  end special measure

#      $bodylength = length($body);

      $bodylength = length($body) + length($message_url_title) + length($message_img);

      if (length($body) > $max_body_length)
      {
         &error(body_long);
      }

   }
   else {
#      &error(no_body);

      $bodylength = length($body) + length($message_url_title) + length($message_img);

   }

   $usrip = $ENV{'REMOTE_ADDR'};

   &check_dup;

   if ($quote_text == 1) {
      $hidden_body = "$body";
      $hidden_body =~ s/</&lt;/g;
      $hidden_body =~ s/>/&gt;/g;
      $hidden_body =~ s/"/&quot;/g;
   }

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

   $year = $year%100;

   if ($sec < 10) {
      $sec = "0$sec";
   }
   if ($min < 10) {
      $min = "0$min";
   }
   if ($hour < 10) {
      $hour = "0$hour";
   }
   if ($mon < 10) {
      $mon = "0$mon";
   }
   if ($year < 10) {
      $year = "0$year";
   }
   if ($mday < 10) {
      $mday = "0$mday";
   }

   $month = ($mon + 1);

   @months = ("January","February","March","April","May","June","July","August","September","October","November","December");

   if ($use_time == 1) {
      $date = "$hour\:$min\:$sec $month/$mday/$year";
   }
   else {
      $date = "$month/$mday/$year";
   }
   chop($date) if ($date =~ /\n$/);

   if ($year eq "99") {
       $long_date = "$months[$mon] $mday, 19$year $hour\:$min\:$sec";
   }
   else {
       $long_date = "$months[$mon] $mday, 20$year $hour\:$min\:$sec";
   }
}      

#####################
# New File Subroutine

sub new_file {

   open(NEWFILE,">$basedir/$mesgdir/$num\.$ext") || die $!;
   print NEWFILE "<html>\n";
   print NEWFILE "  <head>\n";
   print NEWFILE "    <title>$subject</title>\n";
   print NEWFILE "  </head>\n";
   print NEWFILE "  <body bgcolor=\"E5E5E5\">\n";
   print NEWFILE "    <center>\n";
   print NEWFILE "      <h2>$subject</h2>\n";
   print NEWFILE "    </center>\n";
   print NEWFILE "<hr size=7 width=75%>\n";

   print NEWFILE "<!--#echo banner=\"\"--><br>\n";

   if ($show_faq == 1) {
      print NEWFILE "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a><a href=\"$baseurl/$faqfile\"></a> </center>\n";
   }
   else {
      print NEWFILE "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a> </center>\n";
   }
   print NEWFILE "<hr size=7 width=75%><p>\n";

   print NEWFILE "ͽ: ";

   if ($email) {
      print NEWFILE "<a href=\"mailto:$email\">$name</a>  $long_date:<p>\n";
   }
   else {
      print NEWFILE "$name  $long_date:<p>\n";
   }

   if ($followup == 1) {
#      print NEWFILE "ش: <a href=\"$last_message\.$ext\">$origsubject</a>  ";
      print NEWFILE "ش: <a href=\"$baseurl/$mesgdir/$last_message\.$ext\">$origsubject</a>  ";

      if ($origemail) {
         print NEWFILE "<a href=\"$origemail\">$origname</a>  $origdate:<p>\n";
      }
      else {
         print NEWFILE "$origname  $origdate:<p>\n";
      }
   }

   if ($message_img) {
      print NEWFILE "<center><img src=\"$message_img\"></center><p>\n";
   }
   print NEWFILE "$body\n";
   print NEWFILE "<br>\n";
   if ($message_url) {
      print NEWFILE "<ul><li><a href=\"$message_url\">$message_url_title</a></ul>\n";
   }
   print NEWFILE "<br><hr size=7 width=75%>\n";
   print NEWFILE "<BR> \n";

   print NEWFILE "<a name=\"followups\">и:</a><br>\n";
   print NEWFILE "<ul><!--insert: $num-->\n";
   print NEWFILE "</ul><!--end: $num-->\n";
   print NEWFILE "<br><hr size=7 width=75%><p>\n";
   print NEWFILE "<a name=\"postfp\">Ӹ</a><p>\n";
   print NEWFILE "<form method=POST action=\"$cgi_url\">\n";
   print NEWFILE "<input type=hidden name=\"followup\" value=\"";
   if ($followup == 1) {
      foreach $followup_num (@followup_num) {
         print NEWFILE "$followup_num,";
      }
   }
   print NEWFILE "$num\">\n";
   print NEWFILE "<input type=hidden name=\"origname\" value=\"$name\">\n";
   if ($email) {
      print NEWFILE "<input type=hidden name=\"origemail\" value=\"$email\">\n";
   }
   print NEWFILE "<input type=hidden name=\"origsubject\" value=\"$subject\">\n";
   print NEWFILE "<input type=hidden name=\"origdate\" value=\"$long_date\">\n";
   print NEWFILE ": <input type=text name=\"name\" size=16> (ѡ): <input type=text name=\"usrpwd\" size=16><a href=\"$baseurl/register.html\">ע밴</a><br>\n";
   print NEWFILE "<input type=hidden name=\"email\" size=50><p>\n";
   if ($subject_line == 1) {
      if ($subject_line =~ /^Re:/) {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"$subject\">\n";
         print NEWFILE ": <b>$subject</b><p>\n";
      }
      else {
         print NEWFILE "<input type=hidden name=\"subject\" value=\"Re: $subject\">\n";
         print NEWFILE ": <b>Re: $subject</b><p>\n";
      }
   } 
   elsif ($subject_line == 2) {
      print NEWFILE ": <input type=text name=\"subject\" size=50><p>\n";
   }
   else {
      if ($subject =~ /^Re:/) {
         print NEWFILE ": <input type=text name=\"subject\"value=\"$subject\" size=50><p>\n";
      }
      else {
         print NEWFILE ": <input type=text name=\"subject\" value=\"Re: $subject\" size=50><p>\n";
      }
   }
   print NEWFILE "(ѡ):<br>\n";
   print NEWFILE "<textarea name=\"body\" COLS=56 ROWS=10>\n";
   if ($quote_text == 1) {
      @chunks_of_body = split(/\&lt\;p\&gt\;/,$hidden_body);
      foreach $chunk_of_body (@chunks_of_body) {
         @lines_of_body = split(/\&lt\;br\&gt\;/,$chunk_of_body);
         foreach $line_of_body (@lines_of_body) {
            print NEWFILE ": $line_of_body\n";
         }
         print NEWFILE "\n";
      }
   }
   print NEWFILE "</textarea>\n";
   print NEWFILE "<p>\n";
   print NEWFILE "URL(ѡ): <input type=text name=\"url\" size=50><br>\n";
   print NEWFILE "URL(ѡ): <input type=text name=\"url_title\" size=48><br>\n";
   print NEWFILE "ͼ(ѡ): <input type=text name=\"img\" size=49><p>\n";
   print NEWFILE "<input type=submit value=\"ͽ\"> <input type=reset value=\"\">\n";
   print NEWFILE "<p><hr size=7 width=75%>\n";

   if ($show_faq == 1) {
      print NEWFILE "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a><a href=\"$baseurl/$faqfile\"></a> </center>\n";
   }
   else {
      print NEWFILE "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a> </center>\n";
   }
   print NEWFILE "</body></html>\n";
   close(NEWFILE);
}

###############################
# Main WWWBoard Page Subroutine

sub main_page {
   open(MAIN,"$basedir/$mesgfile") || die $!;
   @main = <MAIN>;
   ($zzdev, $zzino, $zzmode, $zznlink, $zzuid, $zzgid, $zzrdev, $zzsize, $zzatime, $zzmtime, $zzctime, $zzblksize, $zzblocks) = stat(MAIN);
   close(MAIN);

   if ($zzsize > 0)
   {
	system("cp $basedir/$mesgfile $basedir/$mesgfile.copy"); 
   }
   else
   {
	system("cp $basedir/$mesgfile.copy $basedir/$mesgfile"); 
   	unlink("$basedir/$busyfile") || die $!;
	&error(system_busy);
   }

#   $bodylength = length($body);

   $bodylength = length($body) + length($message_url_title) + length($message_img);

   if ($bodylength == 0)
   {
       $bodyempty = "()";
   }
   else
   {
       $bodyempty = "";
   }

   open(MAIN,">$basedir/$mesgfile") || die $!;
   if ($followup == 0) {
      foreach $main_line (@main) {
         if ($main_line =~ /<!--begin-->/) {
            print MAIN "<!--begin-->\n";
	    print MAIN "<!--top: $num--><li><a href=\"$baseurl/$mesgdir/$num\.$ext\">$subject $bodyempty</a> - <b>$name</b> ($bodylength bytes) <i>$date</i> ($num)\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   else {
      foreach $main_line (@main) {
	 $work = 0;
         if ($main_line =~ /<ul><!--insert: $last_message-->/) {
            print MAIN "<ul><!--insert: $last_message-->\n";
            print MAIN "<!--top: $num--><li><a href=\"$baseurl/$mesgdir/$num\.$ext\">$subject $bodyempty</a> - <b>$name</b> ($bodylength bytes) <i>$date</i> ($num)\n";
            print MAIN "(<!--responses: $num-->0)\n";
            print MAIN "<ul><!--insert: $num-->\n";
            print MAIN "</ul><!--end: $num-->\n";
         }
         elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		  $work = 1;
               }
            }
            if ($work != 1) {
               print MAIN "$main_line";
            }
         }
         else {
            print MAIN "$main_line";
         }
      }
   }
   close(MAIN);
}

############################################
# Add Followup Threading to Individual Pages
sub thread_pages {

   foreach $followup_num (@followup_num) {
      open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
      @followup_lines = <FOLLOWUP>;
      close(FOLLOWUP);

      open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
      foreach $followup_line (@followup_lines) {
         $work = 0;
         if ($followup_line =~ /<ul><!--insert: $last_message-->/) {
	    print FOLLOWUP "<ul><!--insert: $last_message-->\n";
            print FOLLOWUP "<!--top: $num--><li><a href=\"$baseurl/$mesgdir/$num\.$ext\">$subject</a> - <b>$name</b> ($bodylength bytes) <i>$date</i>\n";
#            print FOLLOWUP "<!--top: $num--><li><a href=\"$num\.$ext\">$subject</a> <b>$name</b> ($bodylength bytes) <i>$date</i>\n";
            print FOLLOWUP "(<!--responses: $num-->0)\n";
            print FOLLOWUP "<ul><!--insert: $num-->\n";
            print FOLLOWUP "</ul><!--end: $num-->\n";
         }
         elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/) {
            $response_num = $1;
            $num_responses = $2;
            $num_responses++;
            foreach $followup_num (@followup_num) {
               if ($followup_num == $response_num) {
                  print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                  $work = 1;
               }
            }
            if ($work != 1) {
               print FOLLOWUP "$followup_line";
            }
         }
         else {
            print FOLLOWUP "$followup_line";
         }
      }
      close(FOLLOWUP);
   }
}

sub return_html {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ѽ: $subject</title></head>\n";
   print "<body bgcolor=\"E5E5E5\"> \n";

   print "<!--#echo banner=\"\"--><br>\n";

   print "<center><h2>Ѽ: $subject</h2></center>\n";
   print "ϢѼ̳:<p><hr size=7 width=75%><p>\n";
   print "<b>:</b> $name \n";

   if ($usrpwd && !$usrpwdf{$name}) {
      print " (ñδעᣬ<a href=\"$baseurl/register.html\">ע밴</a>) \n";
   }

   print "<br> \n";

   if ($email) {
      print "<b>E-Mail:</b> $email<br>\n";
   }
   print "<b>:</b> $subject<br>\n";
   print "<b>:</b><p>\n";
   print "$body<p>\n";
   if ($message_url) {
      print "<b>Link:</b> <a href=\"$message_url\">$message_url_title</a><br>\n";
   }
   if ($message_img) {
      print "<b>Image:</b> <img src=\"$message_img\"><br>\n";
   }
   print "<b>ʱ:</b> $date<p>\n";
   print "<hr size=7 width=75%>\n";
   print "<center> <a href=\"$baseurl/$mesgdir/$num\.$ext\">ռϢ</a><a href=\"$page_url\">$title_p</a> </center>\n";
   print "</body></html>\n";
}

sub increment_num {
   open(NUM,">$basedir/$datafile") || die $!;
   print NUM "$num";
   close(NUM);
}

sub check_flag {
   if (-e "$basedir/$busyfile" && -M "$basedir/$busyfile" < 0.008)
   { 
	&error(system_busy);
   }
   else
   {	
	$now = time;
        utime($now, $now, "$basedir/$busyfile")
 	      || open(FLAG, ">>$basedir/$busyfile")
	      || die $!;

	close(FLAG);
   }
}

sub clear_flag {
   unlink("$basedir/$busyfile") || die $!;
}

sub error {
   $error = $_[0];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name') {
      print "<html><head><title>$title : ûб</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ûб</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "ûͽ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_subject') {
      print "<html><head><title>$title : ûб</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ûб</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "û⣬ͽ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'no_body') {
      print "<html><head><title>$title ERROR: No Message</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>ERROR: No Message</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "You forgot to fill in the 'Message' fieldin your posting.  Correct it below and re-submit.  The necessary fields are: Name, Subjectand Message.<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'wrong_pwd') {
      print "<html><head><title>$title : 벻</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: 벻</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "벻ԣ߸ñѱ˵¼<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'name_pwd_long') {
      print "<html><head><title>$title : ̫</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ̫</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print ": : $max_name_length bytes<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'subject_long') {
      print "<html><head><title>$title : ̫</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ̫</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print ": $max_subj_length bytes<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'body_long') {
      print "<html><head><title>$title : ̫</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ̫</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print ": $max_body_length bytes<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'urim_long') {
      print "<html><head><title>$title : URLURLͼַ̫</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: URLURLͼַ̫</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print ": $max_urim_length bytes<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'post_dup') {
      print "<html><head><title>$title : ظ</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ظ</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "<a href=\"$page_url\">ҳ(ҳ)</a><p><hr size=7 width=75%><p>\n";
#      &rest_of_form;
   }
   elsif ($error eq 'system_busy') {
      print "<html><head><title>$title ϵͳæ</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>ϵͳæ</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "Եһ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   else {
      print "<!--#echo banner=\"\"--> <br>\n";
      print "ERROR!  Undefined.\n";
   }
   exit;
}

sub rest_of_form {

   print "<form method=POST action=\"$cgi_url\">\n";

   if ($followup == 1) {
      print "<input type=hidden name=\"origsubject\" value=\"$FORM{'origsubject'}\">\n";
      print "<input type=hidden name=\"origname\" value=\"$FORM{'origname'}\">\n";
      print "<input type=hidden name=\"origemail\" value=\"$FORM{'origemail'}\">\n";
      print "<input type=hidden name=\"origdate\" value=\"$FORM{'origdate'}\">\n";
      print "<input type=hidden name=\"followup\" value=\"$FORM{'followup'}\">\n";
   }
   print ": <input type=text name=\"name\" value=\"$FORM{'name'}\" size=16>(ѡ): <input type=text name=\"usrpwd\" value=\"$FORM{'usrpwd'}\" size=16><a href=\"$baseurl/register.html\">ע밴</a><br>\n";
   print "<input type=hidden name=\"email\" value=\"$FORM{'email'}\" size=50><p>\n";
   if ($subject_line == 1) {
      print "<input type=hidden name=\"subject\" value=\"$FORM{'subject'}\">\n";
      print "Subject: <b>$FORM{'subject'}</b><p>\n";
   } 
   else {
      print ": <input type=text name=\"subject\" value=\"$FORM{'subject'}\" size=50><p>\n";
   }
   print "(ѡ):<br>\n";
   print "<textarea COLS=56 ROWS=10 name=\"body\">\n";
   $FORM{'body'} =~ s/</&lt;/g;
   $FORM{'body'} =~ s/>/&gt;/g;
   $FORM{'body'} =~ s/"/&quot;/g;
   print "$FORM{'body'}\n";
   print "</textarea><p>\n";
   print "URL(ѡ): <input type=text name=\"url\" value=\"$FORM{'url'}\" size=45><br>\n";
   print "URL(ѡ): <input type=text name=\"url_title\" value=\"$FORM{'url_title'}\" size=50><br>\n";
   print "ͼ(ѡ): <input type=text name=\"img\" value=\"$FORM{'img'}\" size=45><p>\n";
   print "<input type=submit value=\"ͽ\"> <input type=reset value=\"\">\n";
   print "</form>\n";
   print "<br><hr size=7 width=75%>\n";
   if ($show_faq == 1) {
      print "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a><<a href=\"$baseurl/$faqfile\"></a> </center>\n";
   }
   else {
      print "<center> <a href=\"#followups\">и</a><a href=\"#postfp\">Ӹ</a><a href=\"$page_url\">$title_p</a> </center>\n";
   }
   print "</body></html>\n";
}
