#!/usr/local/bin/perl
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# Define Variables

$basedir = "/data1/hypermart.net/freeland/forum";
$reg_url = "http://freeland.hypermart.net/forum/register.pl";
$usrpwdfile = "xxxx_regpwd.txt";
$busyfile = "busy.txt";
$baddiefile = "xxxx_badguy.txt";

$mesgfile = "http://freeland.hypermart.net/forum/mainboard.html";
$addnewfile = "http://freeland.hypermart.net/forum/addnew.html";

# Done
###########################################################################

###########################################################################
# Configure Options

$show_faq = 0;		# 1 - YES; 0 = NO
$allow_html = 1;	# 1 = YES; 0 = NO
$quote_text = 0;	# 1 = YES; 0 = NO
$subject_line = 2;	# 0 = Quote Subject Editable; 1 = Quote Subject 
			#   UnEditable; 2 = Don't Quote Subject, Editable.
$use_time = 1;		# 1 = YES; 0 = NO

$max_name_length = 20;
$max_upwd_length = 20;

# Done
###########################################################################

# Get Form Information
&parse_form;

# Handle Baddie
&handle_baddie;

# Load User Password File
&load_usrpwd;

# Check Flag
&check_flag;

# Put items into nice variables
&get_variables;

# Clear Flag
&clear_flag;

# Return the user HTML
&return_html;

#######################
# Parse Form Subroutine

sub parse_form {

   # Get the input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

   # Split the name-value pairs
   @pairs = split(/&/, $buffer);

   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      # Un-Webify plus signs and %-encoding
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;

      if ($allow_html != 1) {
         $value =~ s/<([^>]|\n)*>//g;
      }
      else {
         unless ($name eq 'body') {
	    $value =~ s/<([^>]|\n)*>//g;
         }
      }

      $FORM{$name} = $value;
   }

}

###############################
# Load User Password Subroutine

sub load_usrpwd {

    open(UPW, "$basedir/$usrpwdfile") || die $!;
    while (<UPW>)
    {
	chop();
	($usrnamef, $usrpwdf) = split(/:/);	
	$usrpwdf{$usrnamef} = $usrpwdf;
    }    
    close(UPW);
}

##########################################
# Add User to The Password File Subroutine

sub add_usrpwd {
    open(UPW, ">>$basedir/$usrpwdfile") || die $!;

    $cryptpwd = crypt($usrpwd, substr($usrpwd, 0, 2)); 

    print UPW "$name:$cryptpwd:$ENV{'REMOTE_ADDR'}\n";
    close(UPW);
}

###############################
# Handle Baddie

sub handle_baddie {

    $usrip = $ENV{'REMOTE_ADDR'};

    open(BAD, "$basedir/$baddiefile") || die $!;
    while (<BAD>)
    {
	chop();
	($baddieip) = split(/:/);	

        if ($usrip =~ /$baddieip/)
        {
	    sleep(300);
	    &error(system_busy);
        }
    }
    close(BAD);
}
###############
# Get Variables

sub get_variables {

   $name = "$FORM{'name'}";
   $name =~ s/://g;
   $name =~ s/"//g;
   $name =~ s/<//g;
   $name =~ s/>//g;
   $name =~ s/\&//g;
   $name =~ s/\s//g;

   $usrpwd = "$FORM{'usrpwd'}";
   $usrpwd =~ s/"//g;
   $usrpwd =~ s/<//g;
   $usrpwd =~ s/>//g;
   $usrpwd =~ s/\&//g;
   $usrpwd =~ s/\s//g;

   if ($name && $usrpwd) 
   {
      if (length($name) < $max_name_length && length($usrpwd) < $max_upwd_length)
      {
      	if ($usrpwdf{$name}) 
      	{
      	     &error(wrong_pwd);
      	}
      	else
      	{
	     &add_usrpwd;
      	}
      }
      else
      {
	&error(name_pwd_long);
      }
   }
   else 
   {
      &error(no_name_pwd);
   }
}      

sub return_html {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ѽ: $subject</title></head>\n";
   print "<body bgcolor=\"E5E5E5\"><center><h1>עɹ</h1></center>\n";
   print "<!--#echo banner=\"\"--> <br>\n";
   print "<b>:</b> $name<br>\n";
   print "<b>:</b> $usrpwd<br>\n";
   print "<a href=$addnewfile></a>\n";
   print "</body></html>\n";
}

sub check_flag {
   if (-e "$basedir/$busyfile" && -M "$basedir/$busyfile" < 0.008)
   { 
	&error(system_busy);
   }
   else
   {	
	$now = time;
        utime($now, $now, "$basedir/$busyfile")
 	      || open(FLAG, ">>$basedir/$busyfile")
	      || die $!;

	close(FLAG);
   }
}

sub clear_flag {
   unlink("$basedir/$busyfile") || die $!;
}

sub error {
   $error = $_[0];

   unlink("$basedir/$busyfile") || die $!;

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name_pwd') {
      print "<html><head><title>$title : ûб</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ûб</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "û룬ͽ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'wrong_pwd') {
      print "<html><head><title>$title : ñѱע</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ñѱע</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "ñѱעᡣ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'name_pwd_long') {
      print "<html><head><title>$title : ̫</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>: ̫</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print ": : $max_name_length bytes, : $max_upwd_length bytes<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   elsif ($error eq 'system_busy') {
      print "<html><head><title>$title ϵͳæ</title></head>\n";
      print "<body bgcolor=\"E5E5E5\"><center><h1>ϵͳæ</h1></center>\n";
      print "<!--#echo banner=\"\"--> <br>\n";
      print "Եһ<p><hr size=7 width=75%><p>\n";
      &rest_of_form;
   }
   else {
      print "<!--#echo banner=\"\"--> <br>\n";
      print "ERROR!  Undefined.\n";
   }
   exit;
}

sub rest_of_form {

   print "<form method=POST action=\"$reg_url\">\n";
   print ": <input type=text name=\"name\" value=\"$FORM{'name'}\" size=16>: <input type=text name=\"usrpwd\" value=\"$FORM{'usrpwd'}\" size=16><p>\n";
   print "<input type=submit value=\"ͽ\"> <input type=reset value=\"\">\n";
   print "</form><p>\n";
   print "<br><hr size=7 width=75%>\n";
   print "</body></html>\n";
}
